/*
 * This script inserts the currently selected track
 * from the track widget.
 *
 * Copyright smf, some ideas taken from the QCad example scripts
 * last change: 2015-01-08
 */

include("../QCTrack.js");

function TrackWidgetRotate(guiAction) {
    EAction.call(this, guiAction);
}

TrackWidgetRotate.prototype = new EAction();

TrackWidgetRotate.includeBasePath = includeBasePath;

TrackWidgetRotate.prototype.beginEvent = function() {
    var connEnd = EAction.getMainWindow().findChild("connEnd");
    if (isNull(connEnd)) {
      return;
    }

    if (connEnd.enabled) {
      var nextConn = connEnd.currentIndex + 1;
      if (nextConn >= connEnd.count) {
        nextConn = 0;
      }
      connEnd.currentIndex = nextConn;
    }
    this.setState(-1);
    this.terminate();
};

TrackWidgetRotate.init = function(basePath) {
    var action = new RGuiAction(QCTrack.MenuItem.TrackWidgetRotate, RMainWindowQt.getMainWindow());
    action.setRequiresDocument(true);
    action.setScriptFile(basePath + "/TrackWidgetRotate.js");
    action.setIcon(basePath + "/TrackWidgetRotate.svg");
    action.setDefaultShortcut(new QKeySequence("q,r"));
    action.setGroupSortOrder(QCTrack.MenuOrder.GroupSortOrder);
    action.setSortOrder(QCTrack.MenuOrder.TrackWidgetRotate);
    EAction.addGuiActionTo(action, QCTrack, true, false, false);
    var appWin = EAction.getMainWindow();
    appWin.addSelectionListener(action);
};

